#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <algorithm>

#include <assert.h>

#define ASSERT(c) assert(c)

#include "node.h"

using namespace std;


/* set */
void node::setID( int i ){ 
    ASSERT( i >= 0 );
    ID = i;
}

void node::setLevel( int i ){ 
    ASSERT( i >= 0 );
    level = i;
}
    
void node::setHtmlNode( string s ){
    htmlnode = s;
}

void node::setParent( node* n ){
    parent = n;
}

void node::setChildren( node* n ){
    children.push_back( n );
}


/* get */
int node::getID(){ 
    ASSERT( ID >= 0 );
    return ID;
}

int node::getLevel(){ 
    ASSERT( level >= 0 );
    return level; 
}
    
string node::getHtmlNode(){
    ASSERT( htmlnode != "" );
    return htmlnode;
}

node* node::getParent() { 
    if( parent == NULL ){ return this; }
    return parent;
}

vector<node*> node::getChildren(){ return children; }

//vector<node*> node::getPath(){ return path; }


/* constructor */
node::node(){
    ID = -1;
    level = -1;
    htmlnode = "";
    parent = NULL;
    children.clear();
}

/* destructer */
node::~node(){

}
    



#if 0
int main(int argc, char* argv[]){

    //if( argc != 2 ){
    //	cout << "Usage: tree [filename]" << endl;
    //	exit(1);
    //}
    //char* filename = argv[1];

    node temp;
    temp.setID(0); temp.setHtmlNode("<html size=20>" );

    cout << temp.getID() << endl;
    cout << temp.getHtmlNode() << endl;

    //temp.setID(-5); temp.setTag("<body>" );

    node temp2;
    //cout << temp2.getID() << endl;
    cout << temp2.getHtmlNode() << endl;


}

#endif
