#ifndef _INC_NODE_
#define _NODE

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <algorithm>

#include <assert.h>

#define ASSERT(c) assert(c)

using namespace std;


class node {
private:
    int ID;
    int level;
    string htmlnode;	 /* html tag and text */
    node* parent;
    vector<node*> children;
//    vector<node*> path;
    
public:
    node();	
    ~node();

    /* set */
    void setID( int i );
    void setLevel( int i ); 
    void setHtmlNode( string s );
    void setParent( node* );
    void setChildren( node* );


    /* get */
    int getID();
    int getLevel();
    string getHtmlNode();
    node* getParent();
    vector<node*> getChildren();
    //vector<node*> getPath();
    
};

#endif
